import numpy as np
from matplotlib import pyplot as plt
import os

#change these
date='01-30-2020'
battery = "battery_name"
ep = 1 # 1 or 3
maximum_energy = 1	# Wh
efficiency_of_battery = 1 # <= 1

#these probably won't change
if ep == 3:
	interval_list = [1,2,3,4,5,6]
else:
	interval_list = [1,2]
length_of_interval = 15 #minutes
direction_list = ['','-']
size_of_state_of_charge_window = .6

#no touchy
if not os.path.isdir("{}/{}".format(date,battery)):
	os.makedirs("{}/{}/".format(date,battery))
print "battery is {}".format(battery)
print "ep is {}".format(ep)
print "the maximum energy of the battery is {}".format(maximum_energy)
print "the maximum power should be {}".format(maximum_energy*size_of_state_of_charge_window/ep)
for no_of_intervals in interval_list:
	for direction in direction_list:
		if direction == '-':
			average_multiplier = -.5 #using this 2 so that things are closer to the values that they should be
			#average_multiplier =  efficiency_of_battery
		else:
			average_multiplier = .5 #using this 2 so that things are closer to the values that they should be
			#average_multiplier = 1
		#-- no touchy
		if average_multiplier < 0:
			power = efficiency_of_battery*maximum_energy*size_of_state_of_charge_window/ep
		else:
			power = maximum_energy*size_of_state_of_charge_window/ep
		upper_power_limit = power * average_multiplier * 2
		print 'maxium power is {}'.format(upper_power_limit)
		total_seconds = no_of_intervals * length_of_interval * 60
		time_list = np.linspace(0,total_seconds,total_seconds+1)
		print 'length of the time list is {}'.format(len(time_list))
		power_list = np.linspace(0,upper_power_limit,total_seconds+1)



		#writing to file
		data = np.array([time_list, power_list])
		data = data.T
		datafile = open('{date}/{battery}/{battery}_{direction}{intervals}.txt'.format(date=date,battery=battery,intervals=no_of_intervals,direction=direction),'w+')
		np.savetxt(datafile, data, fmt=['%.4f','%.8f'])

		#plotting for debugging
		plt.title("{}_{}".format(battery, no_of_intervals))
		plt.plot(time_list,power_list)
		plt.xlabel('time')
		plt.ylabel('power')

plt.show(block=True)


